;##################################################################
; IDebugClient
;##################################################################

#include IDebugClient.h

S= @ADDRESSWIDTH/8

;#define DBG64LIB C:\Programming\RadASM3\GoAsm\dbg\Debug64.lib
;#include C:\Programming\RadASM3\GoAsm\dbg\Debug64.a

IDD_DLG1			equ		1000

CONSTANT SECTION
	IID_IDebugClient GUID GUID_IID_IDebugClient
	IID_IDebugControl GUID GUID_IID_IDebugControl

DATA SECTION
	hInstance			HANDLE 		?
	hDlg				HANDLE		?
	pIDebugClient		PTR			?
	pIDebugControl		PTR			?
	ClassName			TCHAR		"DialogClass",0
	hCodeFont			HANDLE		?
	CodeFont			LOGFONT		<-11,0,0,0,FW_NORMAL,FALSE,FALSE,0,0,0,0,0,0,"Courier New">

CODE SECTION

START:

	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke InitCommonControls

	invoke CreateFontIndirect,OFFSET CodeFont
	mov [hCodeFont],rax

	// Just a label and a bit of code to test with
	KLA:
	and ah,0xf
	xor rax,rax
	
	invoke WinMain,[hInstance],NULL,NULL,SW_SHOW
	invoke DeleteObject,[hCodeFont]
	invoke ExitProcess,0


DisAssemble FRAME hOuput, pTarget, nLines
	uses rbx
	LOCAL status:%UINT_PTR
	LOCAL EndOffset:%UINT_PTR
	LOCAL pBuffer:%UINT_PTR
	LOCAL DisassemblySize:%UINT_PTR

	invoke CoTaskMemAlloc,1024
	mov [pBuffer],rax

	invoke DebugCreate,offset IID_IDebugClient, offset pIDebugClient
	test rax,rax
	jnz >>.DBGCFAIL
	CoInvoke(pIDebugClient,IDebugClient.QueryInterface,offset IID_IDebugControl,offset pIDebugControl)
	test rax,rax
	jnz >>.QIFAIL

	invoke GetCurrentProcessId
	CoInvoke(pIDebugClient,IDebugClient.AttachProcess,0,rax,DEBUG_ATTACH_NONINVASIVE | DEBUG_ATTACH_NONINVASIVE_NO_SUSPEND)
	CoInvoke(pIDebugControl,IDebugControl.WaitForEvent,DEBUG_WAIT_DEFAULT,INFINITE)

	mov rbx,[nLines]
	mov rdx,[pTarget]
	:
	CoInvoke(pIDebugControl,IDebugControl.Disassemble,rdx,DEBUG_DISASM_EFFECTIVE_ADDRESS,[pBuffer],1024,offset DisassemblySize,offset EndOffset)
	invoke SendMessage, [hOuput], EM_SETSEL,-1,-1
	invoke SendMessage, [hOuput], EM_REPLACESEL,TRUE,[pBuffer]
	mov rdx,[EndOffset]
	dec rbx
	jnz <<

	CoInvoke(pIDebugClient,IDebugClient.Release)
	CoInvoke(pIDebugControl,IDebugClient.Release)
	invoke CoTaskMemFree,[pBuffer]
	ret

	.DBGCFAIL
	invoke MessageBox,NULL,"DebugCreate failed",0,0
	ret
	.QIFAIL
	invoke MessageBox,NULL,"QueryInterface failed",0,0
	CoInvoke(pIDebugClient,IDebugClient.Release)
	ret
endf

WinMain FRAME hInst,hPrevInstance,lpCmdLine,nCmdShow
	LOCAL	wc				:WNDCLASSEX
	LOCAL	msg				:MSG
	LOCAL	hdc				:%HANDLE

	; Define our main window class and register it
	mov		D[wc.cbSize], SIZEOF WNDCLASSEX
	mov		D[wc.style], CS_HREDRAW + CS_VREDRAW
	mov		S[wc.lpfnWndProc], OFFSET DlgProc
	mov		D[wc.cbClsExtra], NULL
	mov		D[wc.cbWndExtra], DLGWINDOWEXTRA
	mov		eax, [hInstance]
	mov		S[wc.hInstance], rax
	mov		S[wc.hbrBackground], COLOR_BTNFACE + 1
	mov		S[wc.lpszMenuName], NULL
	mov		S[wc.lpszClassName], OFFSET ClassName
	invoke	LoadIcon, NULL, IDI_APPLICATION
	mov		S[wc.hIcon], rax
	mov		S[wc.hIconSm], rax
	invoke	LoadCursor,NULL,IDC_ARROW
	mov		S[wc.hCursor], rax

	invoke	RegisterClassEx, offset wc
	or rax,rax
	jnz >
		; If we were unable to register the class shut down
		invoke	ExitProcess, -1
	:

	invoke	CreateDialogParam, [hInstance],IDD_DLG1, NULL, NULL, NULL
	or rax,rax
	jnz >
		; If we were unable to create the dialog shut down
		invoke	ExitProcess, -1
	:
	mov [hDlg],rax

	invoke SendDlgItemMessage,[hDlg],1001,WM_SETFONT,[hCodeFont],FALSE

	invoke ShowWindow,[hDlg],[nCmdShow]

	:
		invoke GetMessage, offset msg,NULL,0,0
		or rax,rax
		jz >>
			invoke IsDialogMessage, [hDlg], offset msg
			or rax,rax
			jnz <<
				invoke TranslateMessage, offset msg
				invoke DispatchMessage, offset msg
				jmp <<
	:

	mov rax,[msg.wParam]

	ret
ENDF

DlgProc FRAME hwnd,uMsg,wParam,lParam
	uses ebx

	cmp D[uMsg],WM_CREATE
	jne >.WM_COMMAND
		jmp >>.EXIT

	.WM_COMMAND
	cmp D[uMsg],WM_COMMAND
	jne >.WM_DESTROY
		mov rax,[wParam]
		and rax,0xFFFF
		cmp rax,1002
		jne >>.EXIT
			// Have to turn offf word wrap and set font to <Courier New 11pt>
			invoke GetDlgItem,[hwnd],1001
			invoke DisAssemble, rax,OFFSET KLA, 20
		jmp >.EXIT

	.WM_DESTROY
	cmp D[uMsg],WM_DESTROY
	jne >.DEFPROC
		invoke PostQuitMessage,0

	.DEFPROC
		invoke DefWindowProc,[hwnd],[uMsg],[wParam],[lParam]
		ret

	.EXIT

	xor rax,rax
	ret

ENDF
